=== debian/changelog ===
ros-indigo-darknet (2016.11.27-2trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Yuki Furuta <furushchev@jsk.imi.i.u-tokyo.ac.jp>  Wed, 01 Feb 2017 10:26:45 -0000
