=== debian/control ===
Source: ros-indigo-darknet
Section: misc
Priority: extra
Maintainer: Yuki Furuta <furushchev@jsk.imi.i.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), libopencv-dev, nvidia-cuda-dev, nvidia-cuda-toolkit, ros-indigo-catkin, ros-indigo-rospy, ros-indigo-rostest
Homepage: http://pjreddie.com/darknet/
Standards-Version: 3.9.2

Package: ros-indigo-darknet
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopencv-dev, nvidia-cuda-toolkit
Description: Darknet is an open source neural network framework written in C and CUDA.
 It is fast, easy to install, and supports CPU and GPU computation
